'use strict'

var ContratoController = angular.module('ContratoController', [])

ContratoController.controller('ContratoCtrl', ['$scope', '$filter', '$window', '$sce', 'CacheApp', 'Externo', 'Cliente', 'MsgBox',
  ($scope, $filter, $window, $sce, CacheApp, Externo, Cliente, MsgBox) => {

    if (window.location.hash.indexOf('contratointerno') >= 0) {
        $scope.acessointerno = true
    }

    $scope.fieldValidateFirst = (callBack) => {

        if ($scope.formContrato.txtCnpjcpf.$error.required || $scope.formContrato.txtEmail.$error.required
            || $scope.formContrato.txtNome.$error.required || $scope.formContrato.txtCelular.$error.required
            || $scope.formContrato.txtSenha.$error.required || $scope.formContrato.txtCep.$error.required 
            || $scope.formContrato.txtEndereco.$error.required || $scope.formContrato.txtNumero.$error.required 
            || $scope.formContrato.txtBairro.$error.required) {
                callBack(false)
                return
            }

        if ($scope.Logado) {
            callBack(true)
            return
        }

        if ($scope.contrato.Login) {
            Cliente.ValidaCliente($scope.contrato.Email, $scope.contrato.Senha, 0,
                (data) => {
                    if (data.Code != 0)
                        callBack(false)
                    else {
                        CacheApp.setSessao(data.Instance)
                        $scope.sessao = CacheApp.getSessao()
                        $scope.contrato.IdCliente = $scope.sessao.IdCliente
                        if (!$scope.acessointerno)
                            Cliente.trackingPage('contrato', ()=>{})
                        $scope.atualizaDadosContrato(()=>{
                            callBack(true)
                        })
                    }
                }
            )
        }
        else {
            Cliente.getEmailCadastrado($scope.contrato.Email,
                (cad) => {
                    if (!cad.Instance) {
                        swal(
                            'ATENÇÃO!',
                            `Já existe o e-mail ${$scope.contrato.Email} cadastrado no Vigha.`,
                            'warning'
                        ).then((result) => {
                            callBack(false)
                        })
                    }
                    else
                        Cliente.getSafetyMails($scope.contrato.Email, 
                            (safe) => {
                                var emailInvalido = safe.StatusEmail.indexOf('INVALIDO') == 0
                                if (emailInvalido) {
                                    swal(
                                        'ATENÇÃO!',
                                        'E-mail Inválido!',
                                        'warning'
                                    ).then((result) => {
                                        callBack(false)
                                    })
                                }

                                Cliente.ClienteSalvar(
                                { 
                                    Nome: $scope.contrato.Nome, 
                                    Email: $scope.contrato.Email, 
                                    Senha: $scope.contrato.Senha, 
                                    Celular: $scope.contrato.TelefoneMovel, 
                                    Tipo: 9 
                                }, 
                                0,
                                    (data) => {
                                        if (data.Code != 0)
                                            callBack(false)

                                        CacheApp.setSessao(data.Instance)
                                        $scope.sessao = CacheApp.getSessao()
                
                                        $scope.contrato.IdCliente = $scope.sessao.IdCliente
                                        if (!$scope.acessointerno)
                                            Cliente.trackingPage('contrato', ()=>{})

                                        $scope.atualizaDadosContrato(()=>{
                                            callBack(true)
                                        })
                                    }
                                )                    
                            }
                        )
                }
            )
        }
    }

    $scope.setCadastroAsaas = (contrato) => {
        $scope.fieldValidateFirst(
            (valido) => {
                if (!valido) {
                    return
                }
                $scope.getPlanoSelecionado((plano) => {
                    contrato.IdPlano = plano.Id
                    contrato.NomePlano = plano.Nome

                    var params = {
                        IdCadastroAsaas: contrato.IdCadastroAsaas,
                        IdClienteAsaas: contrato.IdClienteAsaas,
                        IdCliente: contrato.IdCliente,
                        Nome: contrato.Nome,
                        CpfCnpj: contrato.CpfCnpj,
                        Email: contrato.Email,
                        TelefoneFixo: contrato.TelefoneFixo,
                        TelefoneMovel: contrato.TelefoneMovel,
                        Endereco: contrato.Endereco,
                        Numero: contrato.Numero,
                        Complemento: contrato.Complemento,
                        Bairro: contrato.Bairro,
                        Cidade: contrato.Cidade,
                        Estado: contrato.Estado,
                        CEP: contrato.CEP,
                        EmailAdicional: contrato.EmailAdicional,
                        DesabilitaNotificacaoCob: false
                    }
        
                    Cliente.setCadastroAsaasService(params,
                        (data) => {
                            contrato.IdCadastroAsaas = data.Instance.IdCadastroAsaas
                            contrato.IdClienteAsaas = data.Instance.IdClienteAsaas
                            if (!contrato.ValorPlano)
                                $scope.setContratoCliente(contrato, 
                                    (data2) => {
                                        $scope.setCobrancaContrato(contrato, 
                                            (data3) => {
                                                $scope.tela = 0
                                                $scope.urlPagamento = data3.Instance.LinkBoleto
                                                if (!$scope.acessointerno)
                                                    Cliente.trackingPage('cobranca', ()=>{})
                                                $scope.redirecionaPagamento()
                                                Cliente.setNotificacaoCliente({IdClienteAsaas: contrato.IdClienteAsaas}, (data1) => {})
                                            }
                                        )
                                    }
                                )
                            else
                                Cliente.getCobrancaContrato({IdClienteAsaas: contrato.IdClienteAsaas},
                                    (assinatura) => {
                                        if (assinatura.Instance)
                                            Cliente.delCobrancaContrato(assinatura.Instance,
                                                (data) => {
                                                    $scope.setContratoCliente(contrato, 
                                                        (data2) => {
                                                            $scope.setCobrancaContrato(contrato, 
                                                                (data3) => {
                                                                    $scope.tela = 0
                                                                    $scope.urlPagamento = data3.Instance.LinkBoleto
                                                                    if (!$scope.acessointerno)
                                                                        Cliente.trackingPage('cobranca', ()=>{})
                                                                    $scope.redirecionaPagamento()
                                                                    Cliente.setNotificacaoCliente({IdClienteAsaas: contrato.IdClienteAsaas}, (data1) => {})
                                                                }
                                                            )
                                                        }
                                                    )
                                                }
                                            )
                                    })

                        }
                    )
                })
            }
        )
    }

    $scope.excluirContrato = (contrato) => {
        MsgBox.Pergunta('Deseja realmente cancelar o contrato?', 'Não será mais enviada cobrança e sua conta será bloqueada após vencimento da mensalidade atual.', 
        () => {
            Cliente.getCobrancaContrato({IdClienteAsaas: contrato.IdClienteAsaas},
                (assinatura) => {
                    if (assinatura.Instance)
                        Cliente.delCobrancaContrato(assinatura.Instance,
                            (data) => {
                                Cliente.finalizaContratoCliente({IdContratoCliente: contrato.IdContratoCliente},
                                    (data) => {
                                        $scope.atualizaDadosContrato(()=>{
                                        })
                                    });
                            }
                        )
                })
        }
        ,() => {}
        )
            
    }

    $scope.redirecionaPagamento = () => {
        window.open($scope.urlPagamento,'_blank')
    }

    $scope.redirecionaVigha = () => {
        $window.location.href = '/app/mvc/main.html'
    }

    $scope.setContratoCliente = (contrato, callBack) => {
        var params = {
            IdContratoCliente: 0,
            IdCliente: contrato.IdCliente,
            IdPlano: contrato.IdPlano,
            Acessos: contrato.Acessos-1,
            Meses: 1,
            Dividido: 1, // contrato.TipoPagamento == 'CREDIT_CARD' ? contrato.Parcelas : 1,
            ValorMensal: contrato.TipoPagamento == 'BOLETO' ? contrato.ValorFinal : (contrato.ValorFinal*(1-$scope.YearOff)), // contrato.Tipo == 'ASSINATURA' ? contrato.ValorFinal : (contrato.ValorFinal*(1-$scope.YearOff)),
            DataInicio: $filter("date")(contrato.DataVencimento, 'yyyy-MM-ddT03:05:00')
        }
        Cliente.setContratoCliente(params,
            (data) => {
                callBack(data)
            })
    }

    $scope.setCobrancaContrato = (contrato, callBack) => {
        var params = {
            IdClienteAsaas: contrato.IdClienteAsaas,
            Tipo: 'ASSINATURA', // contrato.Tipo,
            Descricao: 'Contratação VIGHA: ' + contrato.NomePlano,
            TipoPagamento: contrato.TipoPagamento,
            Valor: contrato.TipoPagamento == 'BOLETO' ? contrato.ValorFinal : (contrato.ValorFinal*(1-$scope.YearOff)),
            Parcelas: 1, //contrato.TipoPagamento == 'CREDIT_CARD' ? contrato.Parcelas : 1,
            ValorParcela: contrato.TipoPagamento == 'BOLETO' ? contrato.ValorFinal : (contrato.ValorFinal*(1-$scope.YearOff)),
            DataVencimento: $filter("date")(contrato.DataVencimento, 'yyyy-MM-ddT03:05:00')
        }
        Cliente.setCobrancaContrato(params,
            (data) => {
                callBack(data)
            })
    }

    $scope.getListaEstado = () => {
        var params = {
            IdPais: 1
        }
        Externo.getListaEstado(params,
            (data) => {
                $scope.listaEstado = data.Instance
            }
        )
    }

    $scope.getListaCidade = (Estado) => {
        var params = {
            IdEstado: $scope.listaEstado.filter(e => e.UF == Estado)[0].Id
        }
        Externo.getListaCidade(params,
            (data) => {
                $scope.listaCidade = data.Instance
            }
        )
    }

    $scope.getEnderecoCEP = (contrato) => {
        if (contrato.CEP.length != 8) return
        Externo.getEnderecoCEP(contrato.CEP,
            (data) => {
                contrato.Endereco = data.logradouro
                contrato.Bairro = data.bairro
                $scope.listaEstado.forEach(
                    e => {
                        if (e.UF == data.uf) {
                            contrato.IdEstado = e.Id.toString()
                            contrato.Estado = e.UF
                        }
                    }
                )
                var params = {
                    IdEstado: contrato.IdEstado
                }
                Externo.getListaCidade(params,
                    (result) => {
                        $scope.listaCidade = result.Instance
                        $scope.listaCidade.forEach(
                            c => {
                                if (c.Nome == data.localidade) {
                                    contrato.IdCidade = c.Id.toString()
                                    contrato.Cidade = c.Nome
                                }
                            }
                        )
                    }
                )
            }
        )
    }

    $scope.getEnderecoCNPJ = (contrato) => {
        if (!contrato.CpfCnpj || contrato.CpfCnpj.length != 14) return
        var params = {CNPJ: contrato.CpfCnpj}
        Cliente.getDadosCNPJ(params,
            (data) => {
                var dados = data.Instance
                contrato.Nome = dados.nome
                contrato.CEP = dados.cep.replace('.','').replace('-','')
                contrato.Numero = dados.numero
                contrato.Complemento = dados.complemento
                $scope.getEnderecoCEP(contrato)
            }
        )
    }

    $scope.atualizaDadosContrato = (callBack) => {
        $scope.contrato.isContract = false
        Cliente.getCadastroAsaas({IdCliente: $scope.contrato.IdCliente},
            (data)=>{
                if (data.Instance) {
                    $scope.contrato.IdCadastroAsaas = data.Instance.IdCadastroAsaas
                    $scope.contrato.IdClienteAsaas = data.Instance.IdClienteAsaas
                    $scope.contrato.Nome = data.Instance.Nome
                    $scope.contrato.CpfCnpj = data.Instance.CpfCnpj
                    $scope.contrato.Email = data.Instance.Email
                    $scope.contrato.TelefoneFixo = data.Instance.TelefoneFixo
                    $scope.contrato.TelefoneMovel = data.Instance.TelefoneMovel
                    $scope.contrato.Endereco = data.Instance.Endereco
                    $scope.contrato.Numero = data.Instance.Numero
                    $scope.contrato.Complemento = data.Instance.Complemento
                    $scope.contrato.Bairro = data.Instance.Bairro
                    $scope.contrato.Cidade = data.Instance.Cidade
                    $scope.contrato.Estado = data.Instance.Estado
                    $scope.contrato.CEP = data.Instance.CEP

                    $scope.listaEstado.forEach(
                        e => {
                            if (e.UF == $scope.contrato.Estado) {
                                $scope.contrato.IdEstado = e.Id.toString()
                            }
                        }
                    )
                    var params = {
                        IdEstado: $scope.contrato.IdEstado
                    }
                    Externo.getListaCidade(params,
                        (result) => {
                            $scope.listaCidade = result.Instance
                            $scope.listaCidade.forEach(
                                c => {
                                    if (c.Nome == $scope.contrato.Cidade) {
                                        $scope.contrato.IdCidade = c.Id.toString()
                                    }
                                }
                            )
                            callBack()
                        }
                    )

                    var params = {IdCliente: $scope.sessao.IdCliente}
                    Cliente.getContratoCliente(params,
                        (data) => {
                            var contrato = data.Instance.filter(c => !c.DataFim)[0]
                            if (contrato) {
                                // console.log(contrato)
                                var modulosCliente = []
                                $scope.listaModulo.forEach(m => {
                                    m.coluna.forEach(c => {
                                        if (contrato.ChaveAcesso.split(',').filter(a => a.indexOf('GET_')>=0).some(a => a == c.Tag))
                                            modulosCliente.push(c)
                                    })
                                })
                                $scope.contrato.NomePlano = contrato.Plano
                                $scope.contrato.ValorPlano = contrato.ValorMensal
                                $scope.contrato.AcessosPlano = contrato.Acessos
                                $scope.contrato.IdContratoCliente = contrato.IdContratoCliente
                                $scope.contrato.ValorTotal = $scope.contrato.ValorUsuario
                                $scope.contrato.isContract = true
                                // console.log(modulosCliente)
                                modulosCliente.forEach(m => {
                                    $scope.addModulo(m)
                                })
                                var dtIni = new Date(contrato.DataInicio)
                                var dtHj = new Date()
                                dtHj.setDate(dtHj.getDate() + 30)
                                var dtVenc = new Date(dtHj.getFullYear(), dtHj.getMonth(), dtIni.getDate())
                                $scope.contrato.DataVencimento = dtVenc
                            } else {
                                $scope.addModulo($scope.listaModulo[0].coluna[0])
                                $scope.contrato.ValorTotal = $scope.ValorPorUsuario
                            }
                        }
                    )
                }
                else
                    callBack()
            })
    }
    $scope.getListaEstado()

    $scope.getPlanoSelecionado = (callBack) => {
        var planos = []
        $scope.listaPlanos.forEach(p => {
            var itsOk = p.Acessos.indexOf('GET_DOCUMENTO') < 0
            if (itsOk) {
                $scope.contrato.Modulos.forEach(m => {
                    if (p.Acessos.indexOf(m.Tag) < 0)
                        itsOk = false
                })

                if (itsOk)
                    p.Acessos.split(',').filter(a => a.indexOf('GET_') >= 0).forEach(a => {
                        if (!$scope.contrato.Modulos.some(m => m.Tag == a))
                            itsOk = false
                    })
            }
    
            if (itsOk && planos.indexOf(p) < 0)
                planos.push(p)
        })

        if (planos.length == 0) {
            var params = {
                Nome: '',
                Acessos: ''
            }
            $scope.contrato.Modulos.forEach((m,i) => {
                var config = $scope.listaPlanosConfig.filter(p => p.Tag == m.Tag)[0]
                if (i == 0) {
                    params.Nome = config.Nome
                    params.Acessos = config.Acessos
                }
                else {
                    params.Nome += ', '+config.Nome
                    params.Acessos += ','+config.Acessos
                }
            })
            Externo.setPlano(params,(data)=>{
                params.Id = data.Instance.IdPlano
                callBack(params)
            })
        }
        else
            callBack(planos[0])
    }

    $scope.FuncOff = 0.00
    $scope.YearOff = 0.10
    $scope.addModulo = (modulo) => {
        if (!$scope.contrato.ValorModulo)
            $scope.contrato.ValorModulo = 0
        if (!$scope.contrato.ValorTotal)
            $scope.contrato.ValorTotal = 0
        if (!$scope.contrato.Desconto)
            $scope.contrato.Desconto = 0

        if ($scope.contrato.Modulos.some(m => m.Id == modulo.Id)) {
            if (modulo.Tag == 'GET_ORCAMENTO'
                && $scope.contrato.Modulos.some(m => m.Tag == 'GET_PLANEJAR' || m.Tag == 'GET_AVANCO')) {
                    modulo.check = true
                    return
                }

            if (modulo.Tag == 'GET_FINANCEIRO'
                && $scope.contrato.Modulos.some(m => m.Tag == 'GET_INTEGRACAOSEFAZ')) {
                    modulo.check = true
                    return
                }

            $scope.contrato.Modulos.splice($scope.contrato.Modulos.indexOf(modulo),1)
            $scope.contrato.ValorModulo -= modulo.Valor
            $scope.contrato.ValorTotal -= modulo.Valor
            $scope.contrato.Desconto -= $scope.FuncOff
            modulo.check = false

            if ($scope.contrato.Modulos.length <= 1)
                $scope.contrato.Desconto = 0

        }
        else {
            // if (!modulo.AbriuVideo && modulo.Video) {
            //     $scope.showVideoModal(modulo)
            //     modulo.AbriuVideo = true
            // }

            $scope.contrato.Modulos.push(modulo)
            $scope.contrato.ValorModulo += modulo.Valor
            $scope.contrato.ValorTotal += modulo.Valor
            if ($scope.contrato.Modulos.length > 1)
                $scope.contrato.Desconto += $scope.FuncOff

            modulo.check = true
            if (modulo.Orcamento && !$scope.contrato.Modulos.some(m => m.Tag == 'GET_ORCAMENTO')) {
                var moduloOrcamento = {}
                $scope.listaModulo.forEach(m => {
                    m.coluna.forEach(c => {
                        if (c.Tag == 'GET_ORCAMENTO')
                            moduloOrcamento = c
                    })
                })
                    
                moduloOrcamento.check = true
                $scope.contrato.ValorModulo += moduloOrcamento.Valor
                $scope.contrato.ValorTotal += moduloOrcamento.Valor
                $scope.contrato.Desconto += $scope.FuncOff
                $scope.contrato.Modulos.push(moduloOrcamento)
            }
            if (modulo.Financeiro && !$scope.contrato.Modulos.some(m => m.Tag == 'GET_FINANCEIRO')) {
                var moduloFinancceiro = {}
                $scope.listaModulo.forEach(m => {
                    m.coluna.forEach(c => {
                        if (c.Tag == 'GET_FINANCEIRO')
                            moduloFinancceiro = c
                    })
                })
                moduloFinancceiro.check = true
                $scope.contrato.ValorModulo += moduloFinancceiro.Valor
                $scope.contrato.ValorTotal += moduloFinancceiro.Valor
                $scope.contrato.Desconto += $scope.FuncOff
                $scope.contrato.Modulos.push(moduloFinancceiro)
            }
        }

        // $scope.listaModulo.find(m => m.Tag == modulo.Tag).check = modulo.check
        $scope.contrato.DescricaoPlano = $scope.contrato.Modulos.map(m => m.Nome).join(', ')
        // $scope.contrato.DescricaoPlano += ' - ' + $scope.contrato.Acessos.toString() + (contrato.Acessos == 1 ? 'Usuário' : 'Usuários')

        $scope.contrato.ValorFinal = $scope.contrato.ValorUsuario+($scope.contrato.ValorModulo-($scope.contrato.ValorModulo*$scope.contrato.Desconto))
        // $scope.updateParcelas()
    }

    $scope.clickCheck = (modulo) => {
        Cliente.PrimeiroAcesso(`${modulo.check ? 'CHECK': 'UNCHECK'}: ${modulo.Nome}`, (data) => {})
        $scope.addModulo(modulo)
    }

    $scope.getListaModulosLead = () => {
        $scope.listaModulo = [
            {
                linha: 1,
                coluna: [
                    {
                        Id: 1,
                        Nome: 'ORÇAMENTO', 
                        Descricao: 'Faça orçamentos em 1 minutos com nossa IA! Importando sua base própria ou utilizando bases públicas como: SINAPI, ORSE, e SEDOP. Exporte para PDF e Excel relatórios analísticos e sintéticos.', 
                        icon:'glyphicon-pencil', 
                        Acessos: 1,
                        Tipo: 1,
                        Video: 'https://www.youtube.com/embed/FeRZQfzgplU',
                        Tag: 'GET_ORCAMENTO'
                    },
                    {
                        Id: 2, 
                        Nome: 'FINANCEIRO', 
                        Descricao: 'Registre as despesas e receitas de cada obra importantando suas notas fiscais em um click, anexe documentos, separe lançamentos por centro de custo.', 
                        icon:'glyphicon-usd', 
                        Acessos: 1,
                        Tipo: 1,
                        Video: 'https://www.youtube.com/embed/g8Ua0eCvrA0',
                        Tag: 'GET_FINANCEIRO'
                    },
                ]
            },
            {
                linha: 2,
                coluna: [
                    {
                        Id: 3, 
                        Nome: 'INTEGRAÇÃO NF-e', 
                        Descricao: 'Atualize seu financeiro de forma simples com nossa busca automatica na Sefaz às notas fiscais emitidas contra o CNPJ da sua empresa.', 
                        icon:'glyphicon-transfer', 
                        Acessos: 1,
                        Tipo: 1,
                        // Video: 'https://www.youtube.com/embed/g8Ua0eCvrA0?si=vM4evyY6cI6iWP8s',
                        Financeiro: true,
                        Tag: 'GET_INTEGRACAOSEFAZ'
                    },
                    {
                        Id: 4, 
                        Nome: 'COMPRAS', 
                        Descricao: 'Faça solicitações de compras diretamente do canteiro por meio do app. Use o mapa de cotação para comparar os preços de seus fornecedores e fechar bons negócios.', 
                        Valor: $scope.ValorPlano,
                        icon:'glyphicon-shopping-cart', 
                        Acessos: 1,
                        Tipo: 1,
                        Tag: 'GET_COMPRA_SOLICITACAO'
                    },
                ]
            },
            {
                linha: 3,
                coluna: [
                    {
                        Id: 5, 
                        Nome: 'MEDIÇÃO FÍSICA', 
                        Descricao: 'Acompanhe os prazos estabelecidos e avalie a produção do canteiro com maior precisão por meio de gráficos e boletins de medição.', 
                        icon:'glyphicon-road', 
                        Acessos: 1,
                        Tipo: 2,
                        Orcamento: true,
                        Tag: 'GET_AVANCO'
                    },
                    {
                        Id: 6, 
                        Nome: 'DIÁRIO DE OBRAS', 
                        Descricao: 'Registre condições climáticas, equipe que trabalhou no canteiro, equipamentos utilizados, evolução dos serviços executados e ocorrências.', 
                        icon:'glyphicon-book', 
                        Acessos: 1,
                        Tipo: 2,
                        Tag: 'GET_DIARIOOBRA'
                    },
                ]
            },
        ]

        $scope.listaModulo.forEach(m => {
            m.coluna.forEach(c => {
                c.Valor = 95.00
            })
        })

        setTimeout(() => {
            $('[data-toggle="tooltip"]').tooltip() 
        }, 1000)
        
    }

    $scope.getListaModulosCliente = () => {
        $scope.listaModulo = [
            {
                linha: 1,
                coluna: [
                    {
                        Id: 1,
                        Nome: 'ORÇAMENTO', 
                        Descricao: 'Faça orçamentos em 1 minutos com nossa IA! Importando sua base própria ou utilizando bases públicas como: SINAPI, ORSE, e SEDOP. Exporte para PDF e Excel relatórios analísticos e sintéticos.', 
                        icon:'glyphicon-pencil', 
                        Acessos: 1,
                        Tipo: 1,
                        Video: 'https://www.youtube.com/embed/FeRZQfzgplU?si=GD4kmInbPD2cpfmJ',
                        Tag: 'GET_ORCAMENTO'
                    },
                    {
                        Id: 2, 
                        Nome: 'FINANCEIRO', 
                        Descricao: 'Registre as despesas e receitas de cada obra importantando suas notas fiscais em um click, anexe documentos, separe lançamentos por centro de custo.', 
                        icon:'glyphicon-usd', 
                        Acessos: 1,
                        Tipo: 1,
                        Video: 'https://www.youtube.com/embed/g8Ua0eCvrA0?si=vM4evyY6cI6iWP8s',
                        // Video: '3ilrUvROanU',
                        Tag: 'GET_FINANCEIRO'
                    },
                ]
            },
            {
                linha: 2,
                coluna: [
                    {
                        Id: 3, 
                        Nome: 'CRONOGRAMA', 
                        Descricao: 'Associe o controle de custos com o controle de prazos através do cronograma físico-financeiro. Emita o planejamento físico da obra por meio do Gráfico de Gantt resumido ou detalhado..', 
                        icon:'glyphicon-calendar', 
                        Acessos: 1,
                        Orcamento: true,
                        Tipo: 1,
                        Tag: 'GET_PLANEJAR'
                    },
                    {
                        Id: 4,
                        Nome: 'INTEGRAÇÃO NF-e', 
                        Descricao: 'Atualize seu financeiro de forma simples com nossa busca automatica na Sefaz às notas fiscais emitidas contra o CNPJ da sua empresa.', 
                        icon:'glyphicon-transfer', 
                        Acessos: 1,
                        Tipo: 1,
                        // Video: 'https://www.youtube.com/embed/g8Ua0eCvrA0?si=vM4evyY6cI6iWP8s',
                        Financeiro: true,
                        Tag: 'GET_INTEGRACAOSEFAZ'
                    },
                ]
            },
            {
                linha: 3,
                coluna: [
                    {
                        Id: 5, 
                        Nome: 'COMPRAS', 
                        Descricao: 'Faça solicitações de compras diretamente do canteiro por meio do app. Use o mapa de cotação para comparar os preços de seus fornecedores e fechar bons negócios.', 
                        Valor: $scope.ValorPlano,
                        icon:'glyphicon-shopping-cart', 
                        Acessos: 1,
                        Tipo: 1,
                        Tag: 'GET_COMPRA_SOLICITACAO'
                    },
                    {
                        Id: 6, 
                        Nome: 'ESTOQUE', 
                        Descricao: 'Controle as entradas e saídas de materiais e equipamentos do canteiro de obra.', 
                        icon:'glyphicon-home', 
                        Acessos: 1,
                        Tipo: 2,
                        Tag: 'GET_ALMOXARIFADO'
                    },
                ]
            },
            {
                linha: 4,
                coluna: [
                    {
                        Id: 7,
                        Nome: 'MEDIÇÃO FÍSICA', 
                        Descricao: 'Acompanhe os prazos estabelecidos e avalie a produção do canteiro com maior precisão por meio de gráficos e boletins de medição.', 
                        icon:'glyphicon-road', 
                        Acessos: 1,
                        Tipo: 2,
                        Orcamento: true,
                        Tag: 'GET_AVANCO'
                    },
                    {
                        Id: 8,
                        Nome: 'DIÁRIO DE OBRAS', 
                        Descricao: 'Registre condições climáticas, equipe que trabalhou no canteiro, equipamentos utilizados, evolução dos serviços executados e ocorrências.', 
                        icon:'glyphicon-book', 
                        Acessos: 1,
                        Tipo: 2,
                        Tag: 'GET_DIARIOOBRA'
                    },
                ]
            },
            {
                linha: 5,
                coluna: [
                    {
                        Id: 9, 
                        Nome: 'IMAGENS', 
                        Descricao: 'Emita relatórios fotográficos e acompanhe a evolução física de cada etapa da obra, documente e compartilhe os relatórios fotográficos com seus clientes.', 
                        icon:'glyphicon-picture', 
                        Acessos: 1,
                        Tipo: 2,
                        Tag: 'GET_IMAGEM'
                    },
                ]
            }
        ]

        $scope.listaModulo.forEach(m => {
            m.coluna.forEach(c => {
                c.Valor = 95.00
            })
        })

        setTimeout(() => {
            $('[data-toggle="tooltip"]').tooltip() 
        }, 1000)
        
    }

    $scope.getPlanos = (callBack) => {
        Externo.getPlanos(
            (data) => {
                $scope.listaPlanos = data.Instance
                Externo.getPlanosConfig((config) => {
                    $scope.listaPlanosConfig = config.Instance
                    if ($scope.sessao && $scope.sessao.Tipo != 3)
                        $scope.getListaModulosCliente()
                    else
                        $scope.getListaModulosLead()

                    $scope.listaModulo.forEach((linha) => {
                        linha.coluna.forEach((item) => {
                            if (item.Video)
                                item.Video = $sce.trustAsResourceUrl(item.Video)
                        })
                    })
                    callBack()
                })

            }
        )
    }

    $scope.addUser = (plus) => {
        if (plus) {
            $scope.contrato.Acessos++
            $scope.contrato.ValorTotal += $scope.ValorPorUsuario
            $scope.contrato.ValorUsuario += $scope.ValorPorUsuario
            Cliente.PrimeiroAcesso(`ADD USER`, (data) => {})
        }
        else {
            if ($scope.contrato.Acessos > 1) {
                $scope.contrato.Acessos--
                $scope.contrato.ValorTotal -= $scope.ValorPorUsuario
                $scope.contrato.ValorUsuario -= $scope.ValorPorUsuario
                Cliente.PrimeiroAcesso(`DEL USER`, (data) => {})
            }
        }

        $scope.contrato.ValorFinal = $scope.contrato.ValorUsuario+($scope.contrato.ValorModulo-($scope.contrato.ValorModulo*$scope.contrato.Desconto))
        //$scope.updateParcelas()
    }

    // $scope.updateParcelas = () => {
    //     $scope.listaParcelas = []
    //     for (let index = 1; index < 13; index++) {
    //         var valor = (($scope.contrato.ValorFinal*12)-(($scope.contrato.ValorFinal*12)*$scope.YearOff))/(index)
    //         $scope.listaParcelas.push({
    //             Id: index,
    //             Nome: `${index}x (R$ ${(valor).toFixed(2).toString().replace(".", ",").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1.")})`,
    //             Valor: valor
    //         })
    //     }
    // }

    $scope.showVideoModal = (module) => {
        var src = module.Video;
        var css = {
            'maxWidth': $(window).width() - 100,
            'maxHeight': $(window).height() - 100
        };

        var $lightbox = $('#boxvideomodal');
        $lightbox.find('iframe').attr('src', src);
        $lightbox.find('iframe').css(css);
        $lightbox.on('shown.bs.modal', (e) => {
            var $img = $lightbox.find('iframe');
            $lightbox.find('.modal-dialog').css({ 'width': $img.width() });
        });

        $lightbox.on('hide.bs.modal', (e) => {
            $lightbox.find('iframe').attr('src', '');
            $lightbox.off('hide.bs.modal');
        });

        $lightbox.modal('show');
        Cliente.PrimeiroAcesso(`VIDEO: ${module.Nome}`, (data) => {})
    }

    $scope.ValorPorUsuario = 25
    $scope.contrato = {
        IdCadastroAsaas: 0,
        Nome: '',
        Email: '',
        TelefoneMovel: '',
        Endereco: '',
        Bairro: '',
        Periodo: 'A',
        Valor: 0,
        Acessos: 1,
        ValorTotal: $scope.ValorPorUsuario,
        ValorUsuario: $scope.ValorPorUsuario,
        ValorModulo: 0,
        Modulos: []
    }
    var amanha = new Date()
    // amanha.setDate(amanha.getDate() + 1)
    $scope.contrato.DataVencimento = amanha

    Cliente.getSessaoValida((data) => {
        if (data.Code == 0) {
            $scope.sessao = data.Instance
            $scope.contrato.IdCliente = $scope.sessao.IdCliente
            $scope.contrato.Nome = $scope.sessao.Nome
            $scope.contrato.TelefoneMovel = $scope.sessao.Celular
            $scope.contrato.Email = $scope.sessao.Email
            $scope.Logado = true

            if (!$scope.acessointerno)
                Cliente.trackingPage('clickcontrate', ()=>{})

            var path = window.location.hash.replace('#/contrato','')
            var deOnde = path.indexOf('?from=') >= 0 ? 
                path.substring(path.indexOf('?from=')+6,path.length)
                : (
                    path.indexOf('utm_campaign=') >= 0 ? 
                        path.substring(path.indexOf('utm_campaign=')+13,path.length)
                    : (
                        path.length > 0 ? path : '208'
                    )
                )

            $scope.PlanoPrecos = ['PRECO_BASICO','PRECO_GESTAO','PRECO_ENTERPRISE']
            if ($scope.PlanoPrecos.some(i => i == deOnde))
                $scope.contrato.SelectedPlan = $scope.PlanoPrecos.indexOf(deOnde)

            $scope.getPlanos(() => {
                $scope.atualizaDadosContrato(()=>{})
            })
        }
        else {
            var path = window.location.hash.replace('#/contrato','')
            var deOnde = path.indexOf('?from=') >= 0 ? 
                path.substring(path.indexOf('?from=')+6,path.length)
                : (
                    path.indexOf('utm_campaign=') >= 0 ? 
                        path.substring(path.indexOf('utm_campaign=')+13,path.length)
                    : (
                        path.length > 0 ? path : '208'
                    )
                )

            $scope.PlanoPrecos = ['PRECO_BASICO','PRECO_GESTAO','PRECO_ENTERPRISE']
            if ($scope.PlanoPrecos.some(i => i == deOnde))
                $scope.contrato.SelectedPlan = $scope.PlanoPrecos.indexOf(deOnde)

            Cliente.PrimeiroAcesso(`Contrato: ${deOnde}`, (data) => {})
            var storage = localStorage.getItem('DeOnde')
            if (storage) {
              if (!storage.split('|*|').some(s => s == deOnde))
                deOnde = `${deOnde}${storage ? `|*|${storage}` : ''}`
              else
                deOnde = storage
            }
        
            localStorage.setItem('DeOnde', deOnde)
        
            Cliente.PrimeiroAcesso(`Contrato: ${deOnde}`, (data) => {})
            $scope.getPlanos(() => {
                $scope.addModulo($scope.listaModulo[0].coluna[0])
            })
        }

        // if (deOnde == 'BLACKFRIDAY') {
        //     $scope.ValorPorUsuario = 20
        //     $scope.contrato.ValorTotal = 20
        //     $scope.contrato.ValorUsuario = 20
        //     $scope.FuncOff = 0.04
        //     $scope.YearOff = 0.10
        // }

        if (path.indexOf('?idcliente=') >= 0) {
            var IdCliente = path.substring(path.indexOf('?idcliente=')+11,path.length)
        }
    })
}])
